package com.huimv.location.dao.entity;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Timestamp;

@Entity
@Table(name = "beacon")
public class BeaconEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Integer id;

    /**
     * mac地址
     */
    @Column(name = "mac")
    private String mac;

    /**
     * x坐标
     */
    @Column(name = "x")
    private String x;

    /**
     * y坐标
     */
    @Column(name = "y")
    private String y;

    /**
     * z坐标
     */
    @Column(name = "z")
    private String z;

    /**
     * 电池电量
     */
    @Column(name = "battery")
    private Integer battery;

    /**
     * 最后上传时间
     */
    @Column(name = "up_last_time")
    private Long upLastTime;

    @Column(name = "up_last_time2")
    private String upLastTime2;

    /**
     * 时间戳
     */
    @Column(name = "timestamp")
    private Timestamp timestamp;

    /**
     * 最后上传基站
     */
    @Column(name = "last_gateway")
    private String lastGateway;

    @Column(name = "user_data_ts")
    private String userDataTs;

    @Column(name = "user_data")
    private String userData;

    @Column(name = "rssi")
    private String rssi;

    @Column(name = "map_id")
    private String mapId;

    @Column(name = "zone_id")
    private String zoneId;

    @Column(name = "updated_at")
    private String updatedAt;

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    /**
     * mac地址
     */
    public void setMac(String mac) {
        this.mac = mac;
    }

    /**
     * mac地址
     */
    public String getMac() {
        return mac;
    }

    /**
     * x坐标
     */
    public void setX(String x) {
        this.x = x;
    }

    /**
     * x坐标
     */
    public String getX() {
        return x;
    }

    /**
     * y坐标
     */
    public void setY(String y) {
        this.y = y;
    }

    /**
     * y坐标
     */
    public String getY() {
        return y;
    }

    /**
     * z坐标
     */
    public void setZ(String z) {
        this.z = z;
    }

    /**
     * z坐标
     */
    public String getZ() {
        return z;
    }

    /**
     * 电池电量
     */
    public void setBattery(Integer battery) {
        this.battery = battery;
    }

    /**
     * 电池电量
     */
    public Integer getBattery() {
        return battery;
    }

    /**
     * 最后上传时间
     */
    public void setUpLastTime(Long upLastTime) {
        this.upLastTime = upLastTime;
    }

    /**
     * 最后上传时间
     */
    public Long getUpLastTime() {
        return upLastTime;
    }

    public void setUpLastTime2(String upLastTime2) {
        this.upLastTime2 = upLastTime2;
    }

    public String getUpLastTime2() {
        return upLastTime2;
    }

    /**
     * 时间戳
     */
    public void setTimestamp(Timestamp timestamp) {
        this.timestamp = timestamp;
    }

    /**
     * 时间戳
     */
    public Timestamp getTimestamp() {
        return timestamp;
    }

    /**
     * 最后上传基站
     */
    public void setLastGateway(String lastGateway) {
        this.lastGateway = lastGateway;
    }

    /**
     * 最后上传基站
     */
    public String getLastGateway() {
        return lastGateway;
    }

    public void setUserDataTs(String userDataTs) {
        this.userDataTs = userDataTs;
    }

    public String getUserDataTs() {
        return userDataTs;
    }

    public void setUserData(String userData) {
        this.userData = userData;
    }

    public String getUserData() {
        return userData;
    }

    public void setRssi(String rssi) {
        this.rssi = rssi;
    }

    public String getRssi() {
        return rssi;
    }

    public void setMapId(String mapId) {
        this.mapId = mapId;
    }

    public String getMapId() {
        return mapId;
    }

    public void setZoneId(String zoneId) {
        this.zoneId = zoneId;
    }

    public String getZoneId() {
        return zoneId;
    }

    public void setUpdatedAt(String updatedAt) {
        this.updatedAt = updatedAt;
    }

    public String getUpdatedAt() {
        return updatedAt;
    }

    @Override
    public String toString() {
        return "BeaconEntity{" +
                "id=" + id + '\'' +
                "mac=" + mac + '\'' +
                "x=" + x + '\'' +
                "y=" + y + '\'' +
                "z=" + z + '\'' +
                "battery=" + battery + '\'' +
                "upLastTime=" + upLastTime + '\'' +
                "upLastTime2=" + upLastTime2 + '\'' +
                "timestamp=" + timestamp + '\'' +
                "lastGateway=" + lastGateway + '\'' +
                "userDataTs=" + userDataTs + '\'' +
                "userData=" + userData + '\'' +
                "rssi=" + rssi + '\'' +
                "mapId=" + mapId + '\'' +
                "zoneId=" + zoneId + '\'' +
                "updatedAt=" + updatedAt + '\'' +
                '}';
    }
}
