package com.huimv.location.dao.entity;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Timestamp;

@Entity
@Table(name = "locator")
public class LocatorEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false)
    private Integer id;

    /**
     * mac地址
     */
    @Column(name = "mac")
    private String mac;

    /**
     * 基站位置
     */
    @Column(name = "location")
    private String location;

    /**
     * 时间戳
     */
    @Column(name = "update_date")
    private Timestamp updateDate;

    /**
     * 基站IP
     */
    @Column(name = "locator_ip")
    private String locatorIp;

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getId() {
        return id;
    }

    /**
     * mac地址
     */
    public void setMac(String mac) {
        this.mac = mac;
    }

    /**
     * mac地址
     */
    public String getMac() {
        return mac;
    }

    /**
     * 基站位置
     */
    public void setLocation(String location) {
        this.location = location;
    }

    /**
     * 基站位置
     */
    public String getLocation() {
        return location;
    }

    /**
     * 时间戳
     */
    public void setUpdateDate(Timestamp updateDate) {
        this.updateDate = updateDate;
    }

    /**
     * 时间戳
     */
    public Timestamp getUpdateDate() {
        return updateDate;
    }

    /**
     * 基站IP
     */
    public void setLocatorIp(String locatorIp) {
        this.locatorIp = locatorIp;
    }

    /**
     * 基站IP
     */
    public String getLocatorIp() {
        return locatorIp;
    }

    @Override
    public String toString() {
        return "LocatorEntity{" +
                "id=" + id + '\'' +
                "mac=" + mac + '\'' +
                "location=" + location + '\'' +
                "updateDate=" + updateDate + '\'' +
                "locatorIp=" + locatorIp + '\'' +
                '}';
    }
}
