package com.huimv.location.dao.repo;

import com.huimv.location.dao.entity.BeaconEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface BeaconRepo extends JpaRepository<BeaconEntity, Integer>, JpaSpecificationExecutor<BeaconEntity> {

    /**
     * @Method      : getByIdAndStartTimeAndEndTime
     * @Description : 读取信标数据
     * @Params      : [mac, startTime, endTime]
     * @Return      : java.util.List<com.huimv.location.dao.entity.BeaconEntity>
     *
     * @Author      : ZhuoNing
     * @Date        : 2021/9/18
     * @Time        : 17:29
     */
    @Query(nativeQuery = true,value = "SELECT * FROM beacon WHERE mac=?1 AND up_last_time >= ?2 AND up_last_time <= ?3 ORDER BY up_last_time2 ASC ")
    List<BeaconEntity> getByIdAndStartTimeAndEndTime(String mac, String startTime, String endTime);
}